
rawset(_G, "HeatOG_Active", false)

-- NEVER FORGET TO ADD THIS OR DESYNC WILL HAPPEN
addHook("NetVars", function(net)
	HeatOG_Active = net($)
end)

addHook("MapLoad", function(themap)
	if mapheaderinfo[gamemap].lvlttl == "Deserted Heat"
		HeatOG_Active = true;
	else HeatOG_Active = false end
end)

--local HeatOG_Active = false
addHook("MapChange", function(themap)
	if mapheaderinfo[gamemap].lvlttl == "Deserted Heat"
		HeatOG_Active = true;

        for player in players.iterate do
            player.DHeat_Gauge = 25
            player.DHeat_Type = "Orange"
            player.DHeat_BlueTimer = 0
            player.DHeat_GreyTimer = 0
            player.DHeat_RedTimer = 0
            player.DHeat_Aerial = 0
            player.DHeat_DMGtemp = 0
            player.Dheat_FBDrop = nil
        end
	else HeatOG_Active = false end

	-- reset the HUD table
	--HeatOG_DraftTable = {}
end)


-- player thinker:

addHook("PlayerThink", function(player)
--return -- disables the code										<==========
if mapheaderinfo[gamemap].lvlttl == "Deserted Heat"
    -- default values
    if not player.DHeat_Gauge
        player.DHeat_Gauge = 0
        player.DHeat_Type = "Orange"
        player.DHeat_BlueTimer = 0
        player.DHeat_GreyTimer = 0
        player.DHeat_RedTimer = 0
        player.DHeat_Aerial = 0
        player.DHeat_DMGtemp = 0
    end

    if player.spectator == true return end

    -- make sure people who are a little bit late doesn't start with 0 of gauge
    if leveltime < 150 player.DHeat_Gauge = 25 end

    -- shields freeze the temp gauge
    if player.curshield == 1 or player.curshield == 3 -- thunder or flame
        player.DHeat_Type = "Grey"
        player.DHeat_GreyTimer = 2
    elseif player.curshield == 2 -- bubble
        player.DHeat_Type = "Blue"
        player.DHeat_BlueTimer = 2
    end

    -- items effect
    if player.invincibilitytimer > TICRATE*7 player.DHeat_Type = "Grey"; player.DHeat_GreyTimer = 2; end
    if player.hyudorotimer > 0 player.DHeat_Type = "Grey"; player.DHeat_GreyTimer = 2; end

    -------------   SECTOR RELATED   --------------------
    if player.mo.subsector.sector.tag >= 200 and player.mo.subsector.sector.tag <= 299
    and player.DHeat_Type != "Blue"
        player.DHeat_Type = "Grey"
        player.DHeat_GreyTimer = 2
    end

    --print(player.mo.subsector.sector.floorpic)

    if (player.mo.eflags & MFE_UNDERWATER) or (player.mo.eflags & MFE_TOUCHWATER) -- water cooling condition
        player.DHeat_Type = "Blue"
        player.DHeat_BlueTimer = TICRATE/2
    -- TODO: check for texture instead (floorpic, subsector.sector)
    elseif player.mo.subsector.sector.floorpic == "TITOFFR" and player.DHeat_Type != "Blue" and P_IsObjectOnGround(player.mo) -- offroad
        -- shields sneakers hyuudoro and invincibility are immune
        if player.curshield == 0 and player.sneakertimer < TICRATE/4 and player.invincibilitytimer == 0 and player.hyudorotimer == 0
            player.DHeat_Type = "Red"
            player.DHeat_RedTimer = TICRATE/2
        end
    elseif player.DHeat_Type == "Grey"
        -- nothing
    end
    ----------------------------------------------------

    if not P_IsObjectOnGround(player.mo) -- aerial
        player.DHeat_Aerial = $+1
    else player.DHeat_Aerial = 0
    end

    if player.DHeat_Aerial > TICRATE+(TICRATE/2) and player.DHeat_Type != "Blue"
        player.DHeat_Type = "Grey"
        player.DHeat_GreyTimer = 2
        if leveltime%(TICRATE) == 1 player.DHeat_Gauge = $-1 end
    end

    if player.respawn.timer != 0 player.DHeat_Aerial = 0 end -- respawn exception for aerial

    -- default to orange
    if player.DHeat_RedTimer == 0 and player.DHeat_BlueTimer == 0 and player.DHeat_GreyTimer == 0
        player.DHeat_Type = "Orange"
    end

    -- got eggboxed?
    if player.eggmanexplode > 0 and player.DHeat_RedTimer == 0
        player.DHeat_GreyTimer = 0 -- overrides grey
        player.DHeat_BlueTimer = 0 -- overrides blue

        player.DHeat_Type = "Orange"
    end


        
    if player.bot and (player.DHeat_RedTimer == 0 or player.DHeat_DMGtemp <= 0)
        --player.DHeat_Type = "Grey"
        player.DHeat_GreyTimer = 2
    end


    --end

    -- normal (ORANGE) --               THE INCREASE/DECREASE TIMERS
    if player.DHeat_Type == "Orange"
        if leveltime%(TICRATE/2) == 1 player.DHeat_Gauge = $ + 1 end
    end

    -- Keep temp (GREY) -- 
    if player.DHeat_Type == "Grey"
        player.DHeat_Gauge = $ -- Don't increase
    end

    -- Burn (RED) -- 
    if player.DHeat_Type == "Red"
        player.DHeat_GreyTimer = 0 -- overrides grey

        if leveltime%(TICRATE/4) == 1 player.DHeat_Gauge = $ + 2 end
    end

    -- cool (BLUE) --
    if player.DHeat_Type == "Blue"
        player.DHeat_RedTimer = 0 -- overrides red

        if player.curshield == 2 -- bubble will have a nerf version of this
            if leveltime%4 == 2 player.DHeat_Gauge = $ - 1 end
        else
            if leveltime%3 == 1 player.DHeat_Gauge = $ - 2 end
        end
    end
    --for listtags in player.mo.subsector.sector.taglist
    --end

    if player.DHeat_DMGtemp > 0
        if leveltime%4 == 1 player.DHeat_Gauge = $ + 1 end
        player.DHeat_DMGtemp = $ - 1
    elseif player.DHeat_DMGtemp < 0
        if leveltime%2 == 1 player.DHeat_Gauge = $ - 1 end
        player.DHeat_DMGtemp = $ + 1
    end
    
    -- death
    if player.DHeat_Gauge >= 100 and player.respawn.timer == 0
        -- player.DHeat_Type = "CoolDeath"
        -- player.DHeat_CoolDTimer = TICRATE*3
        P_DamageMobj(player.mo, nil, nil, 1, DMG_INSTAKILL)
    end

    if player.deadtimer > 0
        player.DHeat_Gauge = $ - 4
    end

    -- print(player.DHeat_Type)
	-- print(player.DHeat_CoolDTimer)

    -- reduce those timers
    if player.DHeat_RedTimer > 0 player.DHeat_RedTimer = $-1; player.DHeat_Type = "Red" end
    if player.DHeat_BlueTimer > 0 player.DHeat_BlueTimer = $-1; player.DHeat_RedTimer = 0; player.DHeat_GreyTimer = 0; player.DHeat_Type = "Blue" end
    if player.DHeat_GreyTimer > 0 player.DHeat_GreyTimer = $-1; player.DHeat_Type = "Grey" end

    if player.DHeat_Gauge < 0 player.DHeat_Gauge = 0 end

    if player.exiting > 0 player.DHeat_Gauge = 0 end
end
end)




-----------------------------------------------------------------------------------------
-- Attack items
addHook("MobjThinker", function(mobj)
if mapheaderinfo[gamemap].lvlttl == "Deserted Heat"
	--print(mobj.tracer.player.rings)
	if mobj.tracer != nil
		mobj.tracer.player.DHeat_Type = "Blue"
		mobj.tracer.player.DHeat_BlueTimer = 2
	end
    end
end, MT_BUBBLESHIELDTRAP)

addHook("MobjDamage", function(victim, attacker, source, damage, dmgtype)
if mapheaderinfo[gamemap].lvlttl == "Deserted Heat"
    if attacker == nil or victim == nil return end

    if attacker.type == MT_BANANA
        victim.player.DHeat_DMGtemp = -8
    elseif attacker.type == MT_BALLHOG
        victim.player.DHeat_Gauge = $ + 5
    elseif attacker.type == MT_LANDMINE or dmgtype == DMG_EXPLODE
        victim.player.DHeat_DMGtemp = TICRATE*2
    elseif attacker.type == MT_PLAYER and attacker.player.flamedash > 0
        victim.player.DHeat_DMGtemp = TICRATE*2
    elseif attacker.type == MT_PLAYER and attacker.player.bubbleblowup > 0
        victim.player.DHeat_DMGtemp = -TICRATE/2
    end
end
end, MT_PLAYER)